#ifndef RUNNER_H
#define RUNNER_H

#include <QMutexLocker>
#include <QObject>
#include <QThread>
#include <QMutex>
#include <QMap>

class Runner : public QThread
{
    Q_OBJECT
public:
    Runner(QList<QString> pingHosts);
    void refresh();
    uint refreshed();
    const QString currentHost();
    const QMap<QString, double> pingData();
    void setCurrentHost(const QString &currentHost);
    void setPingData(const QMap<QString, double> &pingData);

private:
    QMap<QString, double> pingData_p;
    QList<QString> pingHosts_p;
    QString currentHost_p;
    uint refreshed_p;
    mutable QMutex mutex;

protected:
    void run();
};

#endif // RUNNER_H
